package com.zhentao.groups.im.handler;

import com.alibaba.fastjson2.JSON;
import com.zhentao.groups.im.ImServer;
import com.zhentao.groups.im.MessageType;
import com.zhentao.groups.im.Results;
import com.zhentao.groups.im.command.ChatMessage;
import io.netty.channel.Channel;
import io.netty.channel.ChannelHandlerContext;
import io.netty.channel.group.ChannelGroup;
import io.netty.handler.codec.http.websocketx.TextWebSocketFrame;
import io.netty.util.internal.StringUtil;

public class ChatHandler {


    public static void execute(ChannelHandlerContext ctx, TextWebSocketFrame frame){
        try{
            ChatMessage chat = JSON.parseObject(frame.text(),ChatMessage.class);
            System.err.println(chat);
            switch (MessageType.match(chat.getType())){
                case PRIVATE:
                        if (chat.getTarget()==null){
                            ctx.channel().writeAndFlush(Results.fail("发送消息失败,发送消息请选择发送的人"));
                            return;
                        }

                        Channel channel= ImServer.USERS.get(chat.getTarget());
                    System.err.println(channel);
                        if (channel == null || !channel.isActive()){
                            ctx.channel().writeAndFlush(Results.fail("消息发送失败,对方")+chat.getTarget().toString()+"不在线");
                        }else {

                            channel.writeAndFlush(Results.success("私聊消息("+chat.getId()+")", chat.getContent()));

                        }
                    break;
                case GROUP:
                    if (StringUtil.isNullOrEmpty(chat.getGroupId())) {
                        ctx.channel().writeAndFlush(Results.fail("发送群聊消息失败,请指定群名称"));
                        return;
                    }
                    ChannelGroup group = ImServer.GROUP.get(chat.getGroupId());
                    System.err.println(group);
                    if (group == null) {
                        ctx.channel().writeAndFlush(Results.fail("消息发送失败,群 " + chat.getId() + " 不存在"));
                    } else {
                        group.writeAndFlush(Results.success("群聊消息 发送者(" + chat.getId()+ ")", chat.getContent()));
                    }
                    break;
                default:
                    ctx.channel().writeAndFlush(Results.fail("不支持的消息类型"));
                    break;
            }


        }catch (Exception e){
            ctx.channel().writeAndFlush(Results.fail("发送消息格式错误"));
        }

    }
}
