package com.zhentao.groups.im.handler;

import com.alibaba.fastjson2.JSON;
import com.zhentao.groups.im.Command;
import com.zhentao.groups.im.CommandType;
import com.zhentao.groups.im.Results;
import io.netty.channel.ChannelHandlerContext;
import io.netty.channel.SimpleChannelInboundHandler;
import io.netty.handler.codec.http.websocketx.TextWebSocketFrame;

public class WebSocketHandler extends SimpleChannelInboundHandler<TextWebSocketFrame> {
//    接受信息
    @Override
    protected void channelRead0(ChannelHandlerContext ctx, TextWebSocketFrame frame) throws Exception {
        try{
            //解析
            Command command= JSON.parseObject(frame.text(),Command.class);
            System.err.println("command="+command);
            switch (CommandType.match(command.getCode())) {
//                建立连接
                case CONNECTION:
                    ConnectionHandler.execute(ctx,command);
                    break;
//                    私聊
                case  CHAT:
                    ChatHandler.execute(ctx,frame);
//                    群聊
                case JSON_GROUP:
                    JoinGroupHandler.execute(ctx,command.getGroupId());
                default:
                    ctx.channel().writeAndFlush(Results.fail("不支持CODE"));
                    break;
            }
        }catch (Exception e){
            ctx.channel().writeAndFlush(Results.fail(e.getMessage()));
        }



    }
}
