//package com.zhentao.information.service;
//
//import com.alibaba.fastjson.JSON;
//import com.zhentao.information.cache.ChannelCache;
//import com.zhentao.information.entity.Message;
//import com.zhentao.tool.TokenUtils;
//import io.netty.channel.ChannelHandlerContext;
//import io.netty.handler.codec.http.websocketx.TextWebSocketFrame;
//import lombok.extern.slf4j.Slf4j;
//import org.springframework.stereotype.Service;
//
//import javax.annotation.Resource;
//import java.util.Map;
//import java.util.concurrent.ConcurrentHashMap;
//
///**
// * WebSocket服务类
// * 处理WebSocket连接、消息发送等业务逻辑
// */
//@Slf4j
//@Service
//public class WebSocketService {
//
//    @Resource
//    private ChannelCache channelCache;
//
//    // 存储用户token的Map
//    private final Map<String, String> userTokenMap = new ConcurrentHashMap<>();
//
//    /**
//     * 存储用户token
//     * @param userId 用户ID
//     * @param token 用户token
//     */
//    public void storeUserToken(String userId, String token) {
//        userTokenMap.put(userId, token);
//        log.info("用户 {} 的token已存储", userId);
//    }
//
//    /**
//     * 获取用户token
//     * @param userId 用户ID
//     * @return 用户token
//     */
//    public String getUserToken(String userId) {
//        return userTokenMap.get(userId);
//    }
//
//    /**
//     * 处理用户登录
//     * @param token 用户token
//     * @param ctx Channel上下文
//     */
//    public void handleUserLogin(String token, ChannelHandlerContext ctx) {
//        String userId = TokenUtils.getUserIdFromToken(token);
//        if (userId != null) {
//            // 验证token是否与存储的token匹配
//            String storedToken = userTokenMap.get(userId);
//            if (storedToken != null && storedToken.equals(token)) {
//                // 将用户ID和Channel绑定
//                channelCache.addCache(userId, ctx);
//                log.info("用户 {} 连接成功", userId);
//
//                // 发送连接成功消息
//                Message response = new Message();
//                response.setType("connect_success");
//                response.setContent("连接成功");
//                ctx.channel().writeAndFlush(new TextWebSocketFrame(JSON.toJSONString(response)));
//            } else {
//                log.error("用户 {} 的token验证失败", userId);
//                ctx.close();
//            }
//        } else {
//            log.error("无效的token");
//            ctx.close();
//        }
//    }
//
//    /**
//     * 发送消息给指定用户
//     * @param userId 接收者用户ID
//     * @param message 消息内容
//     * @return 是否发送成功
//     */
//    public boolean sendMessageToUser(String userId, Message message) {
//        ChannelHandlerContext ctx = channelCache.getCache(userId);
//        if (ctx != null) {
//            ctx.channel().writeAndFlush(new TextWebSocketFrame(JSON.toJSONString(message)));
//            return true;
//        }
//        return false;
//    }
//
//    /**
//     * 广播消息给所有在线用户
//     * @param message 消息内容
//     */
//    public void broadcastMessage(Message message) {
//        channelCache.getAllCache().forEach((userId, ctx) -> {
//            ctx.channel().writeAndFlush(new TextWebSocketFrame(JSON.toJSONString(message)));
//        });
//    }
//
//    /**
//     * 检查用户是否在线
//     * @param userId 用户ID
//     * @return 是否在线
//     */
//    public boolean isUserOnline(String userId) {
//        return channelCache.getCache(userId) != null;
//    }
//}